Index: LMDZ6/branches/Amaury_dev/libf/dyn3d/guide_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3d/guide_mod.F90	(revision 5117)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3d/guide_mod.F90	(revision 5118)
@@ -613,316 +611,66 @@
     INCLUDE "paramet.h"
     INCLUDE "comgeom.h"
-    
+
     ! input/output variables
-    INTEGER,                           INTENT(IN)    :: typ
-    INTEGER,                           INTENT(IN)    :: vsize
-    INTEGER,                           INTENT(IN)    :: hsize
-    REAL, DIMENSION(hsize*iip1,vsize), INTENT(INOUT) :: field
+    INTEGER, INTENT(IN) :: typ
+    INTEGER, INTENT(IN) :: vsize
+    INTEGER, INTENT(IN) :: hsize
+    REAL, DIMENSION(hsize * iip1, vsize), INTENT(INOUT) :: field
 
     ! Local variables
-    LOGICAL, SAVE                :: first=.TRUE.
+    LOGICAL, SAVE :: first = .TRUE.
     INTEGER, DIMENSION (2), SAVE :: imin, imax ! averaging domain
-    INTEGER                      :: i,j,l,ij
-    REAL, DIMENSION (iip1)       :: lond       ! longitude in Deg.
-    REAL, DIMENSION (hsize,vsize):: fieldm     ! zon-averaged field
+    INTEGER :: i, j, l, ij
+    REAL, DIMENSION (iip1) :: lond       ! longitude in Deg.
+    REAL, DIMENSION (hsize, vsize) :: fieldm     ! zon-averaged field
 
     IF (first) THEN
-        first=.FALSE.
-!Compute domain for averaging
-        lond=rlonu*180./pi
-        imin(1)=1;imax(1)=iip1;
-        imin(2)=1;imax(2)=iip1;
-        IF (guide_reg) THEN
-            DO i=1,iim
-                IF (lond(i)<lon_min_g) imin(1)=i
-                IF (lond(i)<=lon_max_g) imax(1)=i
-            ENDDO
-            lond=rlonv*180./pi
-            DO i=1,iim
-                IF (lond(i)<lon_min_g) imin(2)=i
-                IF (lond(i)<=lon_max_g) imax(2)=i
-            ENDDO
-        ENDIF
-    ENDIF
-
-    fieldm=0.
-    DO l=1,vsize
-    ! Compute zonal average
-        DO j=1,hsize
-            DO i=imin(typ),imax(typ)
-                ij=(j-1)*iip1+i
-                fieldm(j,l)=fieldm(j,l)+field(ij,l)
-            ENDDO
-        ENDDO 
-        fieldm(:,l)=fieldm(:,l)/REAL(imax(typ)-imin(typ)+1)
-    ! Compute forcing
-        DO j=1,hsize
-            DO i=1,iip1
-                ij=(j-1)*iip1+i
-                field(ij,l)=fieldm(j,l)
-            ENDDO
+      first = .FALSE.
+      !Compute domain for averaging
+      lond = rlonu * 180. / pi
+      imin(1) = 1;imax(1) = iip1;
+      imin(2) = 1;imax(2) = iip1;
+      IF (guide_reg) THEN
+        DO i = 1, iim
+          IF (lond(i)<lon_min_g) imin(1) = i
+          IF (lond(i)<=lon_max_g) imax(1) = i
         ENDDO
+        lond = rlonv * 180. / pi
+        DO i = 1, iim
+          IF (lond(i)<lon_min_g) imin(2) = i
+          IF (lond(i)<=lon_max_g) imax(2) = i
+        ENDDO
+      ENDIF
+    ENDIF
+
+    fieldm = 0.
+    DO l = 1, vsize
+      ! Compute zonal average
+      DO j = 1, hsize
+        DO i = imin(typ), imax(typ)
+          ij = (j - 1) * iip1 + i
+          fieldm(j, l) = fieldm(j, l) + field(ij, l)
+        ENDDO
+      ENDDO
+      fieldm(:, l) = fieldm(:, l) / REAL(imax(typ) - imin(typ) + 1)
+      ! Compute forcing
+      DO j = 1, hsize
+        DO i = 1, iip1
+          ij = (j - 1) * iip1 + i
+          field(ij, l) = fieldm(j, l)
+        ENDDO
+      ENDDO
     ENDDO
 
   END SUBROUTINE guide_zonave
 
-!=======================================================================
-  SUBROUTINE guide_interp(psi,teta)
-  
-  USE exner_hyb_m, ONLY: exner_hyb
-  USE exner_milieu_m, ONLY: exner_milieu
-  USE comconst_mod, ONLY: kappa, cpp
-  USE comvert_mod, ONLY: preff, pressure_exner, bp, ap
-  USE lmdz_q_sat, ONLY: q_sat
-  IMPLICIT NONE
-
-  include "dimensions.h"
-  include "paramet.h"
-  include "comgeom2.h"
-
-  REAL, DIMENSION (iip1,jjp1),     INTENT(IN) :: psi ! Psol gcm
-  REAL, DIMENSION (iip1,jjp1,llm), INTENT(IN) :: teta ! Temp. Pot. gcm
-
-  LOGICAL, SAVE                      :: first=.TRUE.
-  ! Variables pour niveaux pression:
-  REAL, DIMENSION (iip1,jjp1,nlevnc) :: plnc1,plnc2 !niveaux pression guidage
-  REAL, DIMENSION (iip1,jjp1,llm)    :: plunc,plsnc !niveaux pression modele
-  REAL, DIMENSION (iip1,jjm,llm)     :: plvnc       !niveaux pression modele
-  REAL, DIMENSION (iip1,jjp1,llmp1)  :: p           ! pression intercouches 
-  REAL, DIMENSION (iip1,jjp1,llm)    :: pls, pext   ! var intermediaire
-  REAL, DIMENSION (iip1,jjp1,llm)    :: pbarx 
-  REAL, DIMENSION (iip1,jjm,llm)     :: pbary 
-  ! Variables pour fonction Exner (P milieu couche)
-  REAL, DIMENSION (iip1,jjp1,llm)    :: pk
-  REAL, DIMENSION (iip1,jjp1)        :: pks    
-  REAL                               :: prefkap,unskap
-  ! Pression de vapeur saturante
-  REAL, DIMENSION (ip1jmp1,llm)      :: qsat
-  !Variables intermediaires interpolation
-  REAL, DIMENSION (iip1,jjp1,llm)    :: zu1,zu2 
-  REAL, DIMENSION (iip1,jjm,llm)     :: zv1,zv2
-  
-  INTEGER                            :: i,j,l,ij
-  CHARACTER(LEN=20),PARAMETER :: modname="guide_interp"
-  
-    WRITE(*,*)trim(modname)//': interpolate nudging variables'
-! -----------------------------------------------------------------
-! Calcul des niveaux de pression champs guidage
-! -----------------------------------------------------------------
-IF (guide_modele) THEN
-    do i=1,iip1
-        do j=1,jjp1
-            do l=1,nlevnc
-                plnc2(i,j,l)=apnc(l)+bpnc(l)*psnat2(i,j)
-                plnc1(i,j,l)=apnc(l)+bpnc(l)*psnat1(i,j)
-            enddo
-        enddo
-    enddo
-else
-    do i=1,iip1
-        do j=1,jjp1
-            do l=1,nlevnc
-                plnc2(i,j,l)=apnc(l)
-                plnc1(i,j,l)=apnc(l)
-           enddo
-        enddo
-    enddo
-
-END IF
-    IF (first) THEN
-        first=.FALSE.
-        WRITE(*,*)trim(modname)//' : check vertical level order'
-        WRITE(*,*)trim(modname)//' LMDZ :'
-        do l=1,llm
-          WRITE(*,*)trim(modname)//' PL(',l,')=',(ap(l)+ap(l+1))/2. &
-                  +psi(1,jjp1)*(bp(l)+bp(l+1))/2.
-        enddo
-        WRITE(*,*)trim(modname)//' nudging file :'
-        do l=1,nlevnc
-          WRITE(*,*)trim(modname)//' PL(',l,')=',plnc2(1,1,l)
-        enddo
-        WRITE(*,*)trim(modname)//' invert ordering: invert_p=',invert_p
-        IF (guide_u) THEN
-            do l=1,nlevnc
-              WRITE(*,*)trim(modname)//' U(',l,')=',unat2(1,1,l)
-            enddo
-        endif
-        IF (guide_T) THEN
-            do l=1,nlevnc
-              WRITE(*,*)trim(modname)//' T(',l,')=',tnat2(1,1,l)
-            enddo
-        endif
-    endif
-    
-! -----------------------------------------------------------------
-! Calcul niveaux pression modele 
-! -----------------------------------------------------------------
-    CALL pression( ip1jmp1, ap, bp, psi, p )
-    IF (pressure_exner) THEN
-      CALL exner_hyb(ip1jmp1,psi,p,pks,pk)
-    else
-      CALL exner_milieu(ip1jmp1,psi,p,pks,pk)
-    endif
-!    ....  Calcul de pls , pression au milieu des couches ,en Pascals
-    unskap=1./kappa
-    prefkap =  preff  ** kappa
-    DO l = 1, llm
-        DO j=1,jjp1
-            DO i =1, iip1
-                pls(i,j,l) = preff * ( pk(i,j,l)/cpp) ** unskap
-            ENDDO
-        ENDDO
-    ENDDO
-
-!   calcul des pressions pour les grilles u et v
-    do l=1,llm
-        do j=1,jjp1
-            do i=1,iip1
-                pext(i,j,l)=pls(i,j,l)*aire(i,j)
-            enddo
-        enddo
-    enddo
-    CALL massbar(pext, pbarx, pbary )
-    do l=1,llm
-        do j=1,jjp1
-            do i=1,iip1
-                plunc(i,j,l)=pbarx(i,j,l)/aireu(i,j)
-                plsnc(i,j,l)=pls(i,j,l)
-            enddo
-        enddo
-    enddo
-    do l=1,llm
-        do j=1,jjm
-            do i=1,iip1
-                plvnc(i,j,l)=pbary(i,j,l)/airev(i,j)
-            enddo
-        enddo
-    enddo
-
-! -----------------------------------------------------------------
-! Interpolation champs guidage sur niveaux modele (+inversion N/S)
-! Conversion en variables gcm (ucov, vcov...)
-! -----------------------------------------------------------------
-    IF (guide_P) THEN
-        do j=1,jjp1
-            do i=1,iim
-                ij=(j-1)*iip1+i
-                psgui1(ij)=psnat1(i,j)
-                psgui2(ij)=psnat2(i,j)
-            enddo
-            psgui1(iip1*j)=psnat1(1,j)
-            psgui2(iip1*j)=psnat2(1,j)
-        enddo
-    endif
-
-    IF (guide_u) THEN
-        CALL pres2lev(unat1,zu1,nlevnc,llm,plnc1,plunc,iip1,jjp1,invert_p)
-        CALL pres2lev(unat2,zu2,nlevnc,llm,plnc2,plunc,iip1,jjp1,invert_p)
-        do l=1,llm
-            do j=1,jjp1
-                do i=1,iim
-                    ij=(j-1)*iip1+i
-                    ugui1(ij,l)=zu1(i,j,l)*cu(i,j)
-                    ugui2(ij,l)=zu2(i,j,l)*cu(i,j)
-                enddo
-                ugui1(j*iip1,l)=ugui1((j-1)*iip1+1,l)    
-                ugui2(j*iip1,l)=ugui2((j-1)*iip1+1,l)    
-            enddo
-            do i=1,iip1
-                ugui1(i,l)=0.
-                ugui1(ip1jm+i,l)=0.
-                ugui2(i,l)=0.
-                ugui2(ip1jm+i,l)=0.
-            enddo
-        enddo
-    ENDIF
-    
-    IF (guide_T) THEN
-        CALL pres2lev(tnat1,zu1,nlevnc,llm,plnc1,plsnc,iip1,jjp1,invert_p)
-        CALL pres2lev(tnat2,zu2,nlevnc,llm,plnc2,plsnc,iip1,jjp1,invert_p)
-        do l=1,llm
-            do j=1,jjp1
-                IF (guide_teta) THEN
-                    do i=1,iim
-                        ij=(j-1)*iip1+i
-                        tgui1(ij,l)=zu1(i,j,l)
-                        tgui2(ij,l)=zu2(i,j,l)
-                    enddo
-                ELSE
-                    do i=1,iim
-                        ij=(j-1)*iip1+i
-                        tgui1(ij,l)=zu1(i,j,l)*cpp/pk(i,j,l)
-                        tgui2(ij,l)=zu2(i,j,l)*cpp/pk(i,j,l)
-                    enddo
-                ENDIF
-                tgui1(j*iip1,l)=tgui1((j-1)*iip1+1,l)    
-                tgui2(j*iip1,l)=tgui2((j-1)*iip1+1,l)    
-            enddo
-            do i=1,iip1
-                tgui1(i,l)=tgui1(1,l)
-                tgui1(ip1jm+i,l)=tgui1(ip1jm+1,l) 
-                tgui2(i,l)=tgui2(1,l)
-                tgui2(ip1jm+i,l)=tgui2(ip1jm+1,l) 
-            enddo
-        enddo
-    ENDIF
-
-    IF (guide_v) THEN
-
-        CALL pres2lev(vnat1,zv1,nlevnc,llm,plnc1(:,:jjm,:),plvnc,iip1,jjm,invert_p)
-        CALL pres2lev(vnat2,zv2,nlevnc,llm,plnc2(:,:jjm,:),plvnc,iip1,jjm,invert_p)
-
-        do l=1,llm
-            do j=1,jjm
-                do i=1,iim
-                    ij=(j-1)*iip1+i
-                    vgui1(ij,l)=zv1(i,j,l)*cv(i,j)
-                    vgui2(ij,l)=zv2(i,j,l)*cv(i,j)
-                enddo
-                vgui1(j*iip1,l)=vgui1((j-1)*iip1+1,l)    
-                vgui2(j*iip1,l)=vgui2((j-1)*iip1+1,l)    
-            enddo
-        enddo
-    ENDIF
-    
-    IF (guide_Q) THEN
-        ! On suppose qu'on a la bonne variable dans le fichier de guidage:
-        ! Hum.Rel si guide_hr, Hum.Spec. sinon.
-        CALL pres2lev(qnat1,zu1,nlevnc,llm,plnc1,plsnc,iip1,jjp1,invert_p)
-        CALL pres2lev(qnat2,zu2,nlevnc,llm,plnc2,plsnc,iip1,jjp1,invert_p)
-        do l=1,llm
-            do j=1,jjp1
-                do i=1,iim
-                    ij=(j-1)*iip1+i
-                    qgui1(ij,l)=zu1(i,j,l)
-                    qgui2(ij,l)=zu2(i,j,l)
-                enddo
-                qgui1(j*iip1,l)=qgui1((j-1)*iip1+1,l)    
-                qgui2(j*iip1,l)=qgui2((j-1)*iip1+1,l)    
-            enddo
-            do i=1,iip1
-                qgui1(i,l)=qgui1(1,l)
-                qgui1(ip1jm+i,l)=qgui1(ip1jm+1,l) 
-                qgui2(i,l)=qgui2(1,l)
-                qgui2(ip1jm+i,l)=qgui2(ip1jm+1,l) 
-            enddo
-        enddo
-        IF (guide_hr) THEN
-            CALL q_sat(iip1*jjp1*llm,teta*pk/cpp,plsnc,qsat)
-            qgui1=qgui1*qsat*0.01 !hum. rel. en %
-            qgui2=qgui2*qsat*0.01 
-        ENDIF
-    ENDIF
-
-  END SUBROUTINE guide_interp
-
-!=======================================================================
-  SUBROUTINE tau2alpha(typ,pim,pjm,factt,taumin,taumax,alpha)
-
-! Calcul des constantes de rappel alpha (=1/tau)
-
-    USE comconst_mod, ONLY: pi
-    USE serre_mod, ONLY: clon, clat, grossismx, grossismy
-    
+  !=======================================================================
+  SUBROUTINE guide_interp(psi, teta)
+
+    USE exner_hyb_m, ONLY: exner_hyb
+    USE exner_milieu_m, ONLY: exner_milieu
+    USE comconst_mod, ONLY: kappa, cpp
+    USE comvert_mod, ONLY: preff, pressure_exner, bp, ap
+    USE lmdz_q_sat, ONLY: q_sat
     IMPLICIT NONE
 
